<?php
/**
 * 仅做演示,请勿生产环境使用
 */
define('DS', DIRECTORY_SEPARATOR);
define('DIR_IMAGE', 'upload/');

$param = $_REQUEST;
$fm = new ImageManager();
$fm->init_dir('');

if ($param['action']) {
    $rs = call_user_func_array([ & $fm, $param['action']], [$param]);
    echo json_encode($rs);
}

class ImageManager
{
    //用户图片目录
    protected $user_image_dir;
    //图片保存路径
    protected $upload_url;
    protected $module;
    public function init_dir($user_image_dir, $module = 'admin')
    {
        $this->user_image_dir = $user_image_dir;
        $this->module = $module;
        $this->upload_url = DIR_IMAGE . $this->user_image_dir;
        if (!is_dir($this->upload_url)) {
            mkdir($this->upload_url, 0777);
            chmod($this->upload_url, 0777);
            fopen($this->upload_url . '/index.html', 'wb');
        }
    }


    //生成测试数据
    public function get_file_data_vm($data){
        $limit = isset($data['limit']) ? $data['limit'] : 16;
        $_ext_arr = ['ai','dir','fonts','mm','pages','txt','zip','apk','doc','ipa','mmap','pdf','visio','bt','eps','keynote','mp3','ppt','web','cad','exe','links','mp4','ps','xls','code','fla','misc','number','rar','xmind'];
        $_realpic_arr = [
            'ico/ai.png'
            ,'ico/apk.png'
            ,'ico/bt.png'
            ,'ico/cad.png'
            ,'ico/code.png'
            ,'ico/dir.png'
            ,'ico/doc.png'
            ,'ico/eps.png'
        ];
        for ($i=0; $i < $limit-5; $i++) { 
            $_ext = $_ext_arr[array_rand($_ext_arr)];
            $_name = $this->createRandomStr(5);
            $name = $_ext == 'dir' ? $_name : $_name.'.'.$_ext;
            $type = $_ext == 'dir' ? 'directory' : $_ext;
            $path = $_ext == 'dir' ? $_name : $name;
            $rs['images'][] = [
                'thumb'=>$_name.'.'.$_ext
                ,'name'=>$name
                ,'type'=>$type
                ,'path'=>$path
            ];
        }
        for ($i=0; $i < 5; $i++) {
            $name = $_realpic_arr[array_rand($_realpic_arr)];
            $rs['images'][] = [
                'thumb'=>$_realpic_arr[array_rand($_realpic_arr)]
                ,'name'=>$this->createRandomStr(5).'jpg'
                ,'type'=>'jpg'
                ,'path'=>$name
            ];
        }
        shuffle($rs['images']);
        $rs['count'] = $limit*mt_rand(1,5);
        return $rs;
    }
    private function  createRandomStr($length){
        $str = array_merge(range(0,9),range('a','z'),range('A','Z'));
        shuffle($str);
        $str = implode('',array_slice($str,0,$length));
        return $str;
    }
    //取得图片文件，文件夹数据，分页数据
    public function get_file_data($data)
    {
        if (isset($data['filter_name'])) {
            $filter_name = rtrim(str_replace(array('../', '..\\', '..', '*'), '', $data['filter_name']), '/');
        } else {
            $filter_name = null;
        }
        //验证是否有这个文件夹
        if (isset($data['path'])) {

            $dir = $data['path'];

            $directory = rtrim($this->upload_url . '/' . str_replace(array('../', '..\\', '..'), '', $dir), '/');
        } else {
            $directory = $this->upload_url;
        }

        if (isset($data['page'])) {
            $page = $data['page'];
        } else {
            $page = 1;
        }
        $limit = isset($data['limit']) ? $data['limit'] : 16;
        $images_and_directory = [];
        //取得文件夹
        $directories = glob($directory . '/' . $filter_name . '*', GLOB_ONLYDIR);
        if (!$directories) {
            $directories = array();
        }
        //取得文件
        $files = glob($directory . '/' . $filter_name . '*.{jpg,jpeg,png,gif,JPG,JPEG,PNG,GIF}', GLOB_BRACE);
        if (!$files) {
            $files = array();
        }
        //合并文件夹和文件
        $images = array_merge($directories, $files);
        //计算文件和文件夹数量
        $image_total = count($images);
        // Split the array based on current page number and max number of items per page of 10
        $images = array_splice($images, ($page - 1) * $limit, $limit);
        if (empty($images)) {
            return ['images' => []];
        }
        foreach ($images as $image) {
            $name = str_split(basename($image), 14);
            if (is_dir($image)) {
                $url = [];
                $path = mb_substr($image, mb_strlen(DIR_IMAGE), mb_strlen($image));
                $p = explode('/', $path);
                if (count($p) > 1) {
                    $d = '';
                    foreach ($p as $k => $v) {
                        if ($v != 'images' && $v != $this->user_image_dir) {
                            $d .= $v . '-';
                        }
                    }
                    $d = substr($d, 0, strlen($d) - 1);
                    $url['directory'] = $d;
                } else {
                    $url['directory'] = end($p);
                }
                if (isset($data['target'])) {
                    $url['target'] = $data['target'];
                }
                if (isset($data['thumb'])) {
                    $url['thumb'] = $data['thumb'];
                }
                $images_and_directory['images'][] = array(
                    'thumb' => '',
                    'name' => implode(' ', $name),
                    'type' => 'directory',
                    'path' => $path,
                );
            } elseif (is_file($image)) {
                $images_and_directory['images'][] = array(
                    'thumb' => $image,
                    'name' => implode(' ', $name),
                    'type' => 'image',
                    'path' => mb_substr($image, mb_strlen(DIR_IMAGE), mb_strlen($image)),
                );
            }
        }

        $images_and_directory['count'] = $image_total;
        return $images_and_directory;
    }

}
